#include "CommonDefines.h"
#include "SimpleTokenizer.h"

#ifndef LEXER
#define LEXER

typedef SimpleTokenizer Tokenizer;

typedef enum
{
    None,
    Other,
    Operand,
    OperatorPlus,
    OperatorMinus,
    OperatorMul,
    OperatorDiv,
    ParOpen,
    ParClose,
} SymbolType;

typedef struct
{
    Tokenizer* tokenizer;
    SymbolType currentTokenType;
} ExpressionLexer;

#endif

ExpressionLexer* newExpressionLexer(char expression[]);
void destroyExpressionLexer(ExpressionLexer *lexer);
boolean readNextTokenFromLex(ExpressionLexer* lexer);
void getCurrentTokenFromLex(ExpressionLexer* lexer, Token t);
SymbolType getCurrentTokenType(ExpressionLexer* lexer);

void expressionLexerTest();